diff --git a/gcc/rust/Make-lang.in b/gcc/rust/Make-lang.in
index a906516bd33..c5960530d0a 100644
--- a/gcc/rust/Make-lang.in
+++ b/gcc/rust/Make-lang.in
@@ -74,6 +74,7 @@ GRS_OBJS = \
     rust/rust-cfg-parser.o \
     rust/rust-parse.o \
     rust/rust-ast-full-test.o \
+    rust/rust-ast-fragment.o \
     rust/rust-ast-dump.o \
     rust/rust-hir-dump.o \
     rust/rust-session-manager.o \
diff --git a/gcc/rust/ast/rust-ast-fragment.cc b/gcc/rust/ast/rust-ast-fragment.cc
new file mode 100644
index 00000000000..1a2dd99835a
--- /dev/null
+++ b/gcc/rust/ast/rust-ast-fragment.cc
@@ -0,0 +1,168 @@
+// Copyright (C) 2020-2022 Free Software Foundation, Inc.
+
+// This file is part of GCC.
+
+// GCC is free software; you can redistribute it and/or modify it under
+// the terms of the GNU General Public License as published by the Free
+// Software Foundation; either version 3, or (at your option) any later
+// version.
+
+// GCC is distributed in the hope that it will be useful, but WITHOUT ANY
+// WARRANTY; without even the implied warranty of MERCHANTABILITY or
+// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+// for more details.
+
+// You should have received a copy of the GNU General Public License
+// along with GCC; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+#include "rust-ast-fragment.h"
+
+namespace Rust {
+namespace AST {
+
+Fragment::Fragment (std::vector<SingleASTNode> nodes, bool fragment_is_error)
+  : kind (fragment_is_error ? FragmentKind::Error : FragmentKind::Complete),
+    nodes (std::move (nodes))
+{
+  if (fragment_is_error)
+    rust_assert (nodes.empty ());
+}
+
+Fragment::Fragment (Fragment const &other) : kind (other.get_kind ())
+{
+  nodes.clear ();
+  nodes.reserve (other.nodes.size ());
+  for (auto &n : other.nodes)
+    {
+      nodes.push_back (n);
+    }
+}
+
+Fragment &
+Fragment::operator= (Fragment const &other)
+{
+  nodes.clear ();
+  nodes.reserve (other.nodes.size ());
+  kind = other.get_kind ();
+  for (auto &n : other.nodes)
+    {
+      nodes.push_back (n);
+    }
+
+  return *this;
+}
+
+Fragment
+Fragment::create_error ()
+{
+  return Fragment ({}, true);
+}
+
+std::vector<SingleASTNode> &
+Fragment::get_nodes ()
+{
+  return nodes;
+}
+
+FragmentKind
+Fragment::get_kind () const
+{
+  return kind;
+}
+
+bool
+Fragment::is_error () const
+{
+  return get_kind () == FragmentKind::Error;
+}
+
+bool
+Fragment::should_expand () const
+{
+  return !is_error ();
+}
+
+bool
+Fragment::is_expression_fragment () const
+{
+  return is_single_fragment_of_kind (SingleASTNode::NodeType::EXPRESSION);
+}
+
+bool
+Fragment::is_type_fragment () const
+{
+  return is_single_fragment_of_kind (SingleASTNode::NodeType::TYPE);
+}
+
+std::unique_ptr<Expr>
+Fragment::take_expression_fragment ()
+{
+  assert_single_fragment (SingleASTNode::NodeType::EXPRESSION);
+  return nodes[0].take_expr ();
+}
+
+std::unique_ptr<Type>
+Fragment::take_type_fragment ()
+{
+  assert_single_fragment (SingleASTNode::NodeType::TYPE);
+  return nodes[0].take_type ();
+}
+
+void
+Fragment::accept_vis (ASTVisitor &vis)
+{
+  for (auto &node : nodes)
+    node.accept_vis (vis);
+}
+
+bool
+Fragment::is_single_fragment () const
+{
+  return nodes.size () == 1;
+}
+
+bool
+Fragment::is_single_fragment_of_kind (SingleASTNode::NodeType expected) const
+{
+  return is_single_fragment () && nodes[0].get_kind () == expected;
+}
+
+void
+Fragment::assert_single_fragment (SingleASTNode::NodeType expected) const
+{
+  static const std::map<SingleASTNode::NodeType, const char *> str_map = {
+    {SingleASTNode::NodeType::IMPL, "impl"},
+    {SingleASTNode::NodeType::ITEM, "item"},
+    {SingleASTNode::NodeType::TYPE, "type"},
+    {SingleASTNode::NodeType::EXPRESSION, "expr"},
+    {SingleASTNode::NodeType::STMT, "stmt"},
+    {SingleASTNode::NodeType::EXTERN, "extern"},
+    {SingleASTNode::NodeType::TRAIT, "trait"},
+    {SingleASTNode::NodeType::TRAIT_IMPL, "trait impl"},
+  };
+
+  auto actual = nodes[0].get_kind ();
+  auto fail = false;
+
+  if (!is_single_fragment ())
+    {
+      rust_error_at (Location (), "fragment is not single");
+      fail = true;
+    }
+
+  if (actual != expected)
+    {
+      rust_error_at (
+	Location (),
+	"invalid fragment operation: expected %qs node, got %qs node",
+	str_map.find (expected)->second,
+	str_map.find (nodes[0].get_kind ())->second);
+      fail = true;
+    }
+
+  rust_assert (!fail);
+}
+
+} // namespace AST
+} // namespace Rust
diff --git a/gcc/rust/ast/rust-ast-fragment.h b/gcc/rust/ast/rust-ast-fragment.h
new file mode 100644
index 00000000000..ee6ab0d8433
--- /dev/null
+++ b/gcc/rust/ast/rust-ast-fragment.h
@@ -0,0 +1,104 @@
+// Copyright (C) 2020-2022 Free Software Foundation, Inc.
+
+// This file is part of GCC.
+
+// GCC is free software; you can redistribute it and/or modify it under
+// the terms of the GNU General Public License as published by the Free
+// Software Foundation; either version 3, or (at your option) any later
+// version.
+
+// GCC is distributed in the hope that it will be useful, but WITHOUT ANY
+// WARRANTY; without even the implied warranty of MERCHANTABILITY or
+// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+// for more details.
+
+// You should have received a copy of the GNU General Public License
+// along with GCC; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+#ifndef RUST_AST_FRAGMENT_H
+#define RUST_AST_FRAGMENT_H
+
+#include "rust-ast.h"
+#include "rust-system.h"
+
+namespace Rust {
+namespace AST {
+
+enum class FragmentKind
+{
+  /**
+   * If an AST Fragment still contains unexpanded tokens - this should only be
+   * used in the case of builtin macros which need to be expanded eagerly.
+   */
+  Unexpanded,
+  /**
+   * A completely expanded AST Fragment. This signifies that all
+   * `SingleASTNode`s in the `nodes` vector are valid.
+   *
+   * Note that this doesn't imply that the expansion is "done". One of the
+   * expanded nodes could very well be another macro invocation
+   */
+  Complete,
+  /**
+   * An error fragment.
+   */
+  Error,
+};
+
+/**
+ * An AST Fragment. Previously named `ASTFragment`.
+ *
+ * Basically, a "fragment" that can be incorporated into the AST, created as
+ * a result of macro expansion. Really annoying to work with due to the fact
+ * that macros can really expand to anything. As such, horrible representation
+ * at the moment.
+ */
+class Fragment
+{
+public:
+  Fragment (std::vector<SingleASTNode> nodes, bool fragment_is_error = false);
+  Fragment (Fragment const &other);
+  static Fragment create_error ();
+
+  Fragment &operator= (Fragment const &other);
+
+  FragmentKind get_kind () const;
+  std::vector<SingleASTNode> &get_nodes ();
+
+  bool is_error () const;
+  bool should_expand () const;
+
+  bool is_expression_fragment () const;
+  bool is_type_fragment () const;
+
+  std::unique_ptr<Expr> take_expression_fragment ();
+  std::unique_ptr<Type> take_type_fragment ();
+
+  void accept_vis (ASTVisitor &vis);
+
+private:
+  FragmentKind kind;
+
+  /**
+   * Basic idea: essentially, a vector of tagged unions of different AST node
+   * types. Now, this could actually be stored without a tagged union if the
+   * different AST node types had a unified parent, but that would create
+   * issues with the diamond problem or significant performance penalties. So
+   * a tagged union had to be used instead. A vector is used to represent the
+   * ability for a macro to expand to two statements, for instance.
+   */
+  std::vector<SingleASTNode> nodes;
+
+  /**
+   * We need to make a special case for Expression and Type fragments as only
+   * one Node will be extracted from the `nodes` vector
+   */
+  bool is_single_fragment () const;
+  bool is_single_fragment_of_kind (SingleASTNode::NodeType expected) const;
+  void assert_single_fragment (SingleASTNode::NodeType expected) const;
+};
+} // namespace AST
+} // namespace Rust
+
+#endif // !RUST_AST_FRAGMENT_H